import paho.mqtt.client as mqtt

# Callback when the client connects to the broker
def on_connect(client, userdata, flags, rc):

    print(f"Connected with result code {rc}")
    # Subscribe to a topic when connected
    client.subscribe("#")

# Callback when a message is received from the broker
def on_message(client, userdata, msg):
    with open("mqtt_messages.txt", "a", encoding='utf-8') as file:
        file.write(f"Topic: {msg.topic}\n")
        file.write(f"Message: {msg.payload.decode()}\n")
        file.write("---------------------------------------\n")



# Create a client instance
client = mqtt.Client()


# Set the username and password
username = "kubetutorial"
password = "supersecurepass"
client.username_pw_set(username, password)

# Set the callbacks
client.on_connect = on_connect
client.on_message = on_message

# Connect to the broker
client.connect("mqtt-broker.default.svc.cluster.local", 1883, 60)

# Start the network loop
client.loop_forever()
