from flask import Flask, request, render_template
import urllib3
import socket
import json

app = Flask(__name__)

@app.route('/', methods=['GET','POST'])
def index():
    http = urllib3.PoolManager()

    # Specify the URL you want to make a GET request to
    url = "http://backend.default.svc.cluster.local:5000"

    # Make the GET request
    try:
        response = http.request("GET", url)

        # Print the response status code and content
        print("Response Status:", response.status)
        print("Response Content:", response.data.decode("utf-8"))
        full_reponse = f"Response Status: {response.status}, Response Content: {response.data.decode('utf-8')}"
        return full_reponse
    except Exception as e:
        # Ejemplo de uso
        hostname = "backend.default.svc.cluster.local"
        ip_address = resolve_dns(hostname)
        a =f"IP address of {hostname}: {ip_address}"
        return  a + ":::: "+str(e)
    

@app.route('/initialize', methods=['GET'])
def initialize():
    http = urllib3.PoolManager()

    # Specify the URL you want to make a GET request to
    url = "http://backend.default.svc.cluster.local:5000/initialize"

    # Make the GET request
    try:
        response = http.request("GET", url)

        # Print the response status code and content
        print("Response Status:", response.status)
        print("Response Content:", response.data.decode("utf-8"))
        full_reponse = f"Response Status: {response.status}, Response Content: {response.data.decode('utf-8')}"
        return full_reponse
    except Exception as e:
        # Ejemplo de uso
        hostname = "backend.default.svc.cluster.local"
        ip_address = resolve_dns(hostname)
        a =f"IP address of {hostname}: {ip_address}"
        return  a + ":::: "+str(e)


@app.route('/mqtt', methods=['GET','POST'])
def mqtt_endpoint():
    http = urllib3.PoolManager()

    # Specify the URL you want to make a GET request to
    

    if request.method == 'POST':
        # Make the GET request
        try:
            mac_address = request.form.get('mac_address')
            url = f"http://backend.default.svc.cluster.local:5000/mqtt_messages?mac={mac_address}"


            response = http.request("GET", url)
            # response.raise_for_status()  # Raise an error for bad responses (4xx or 5xx)
            # Print the response status code and content
            print("Response Status:", response.status)
            print("Response Content:", response.data.decode("utf-8"))
            full_reponse = f"Response Status: {response.status}, Response Content: {response.data.decode('utf-8')}"
            return full_reponse

        except Exception as e:
            # Ejemplo de uso
            hostname = "backend.default.svc.cluster.local"
            ip_address = resolve_dns(hostname)
            a =f"IP address of {hostname}: {ip_address}"
            return  a + ":::: "+str(e)

    return render_template('mac_input_form.html')




def resolve_dns(hostname):
    try:
        ip = socket.gethostbyname(hostname)
        return ip
    except socket.gaierror as e:
        return f"Error: {e}"




if __name__ == '__main__':
    app.run(host="0.0.0.0", port=80, debug=True)
